//+------------------------------------------------------------------+
//|                                           Ticks Volume Indicator |
//|                                         Copyright © William Blau |
//|                                    Coded/Verified by Profitrader |
//+------------------------------------------------------------------+
#property copyright "Copyright © 2016, Profitrader."
#property link      "profitrader@inbox.ru"
#property description "edited by eevviill"
#property description "TVI2"

//-----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 clrBlue
#property indicator_color2 clrRed

#property indicator_level1 0.00
#property indicator_levelcolor clrBlack

//---- input parameters
extern int r=12;
extern int r2=22;
extern int s=10;
extern int s2=20;
extern int u=5;
extern int u2=7;
//---- buffers
double TVI[];
double TVI2[];
double UpTicks[];
double DownTicks[];
double EMA_UpTicks[];
double EMA_DownTicks[];
double DEMA_UpTicks[];
double DEMA_DownTicks[];
double TVI_calculate[];

double MyPoint;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("TVI 2("+r+","+s+","+u+")");
   IndicatorBuffers(9);
   SetIndexBuffer(0,TVI);
   SetIndexBuffer(1,TVI2);
   SetIndexBuffer(2,UpTicks);
   SetIndexBuffer(3,DownTicks);
   SetIndexBuffer(4,EMA_UpTicks);
   SetIndexBuffer(5,EMA_DownTicks);
   SetIndexBuffer(6,DEMA_UpTicks);
   SetIndexBuffer(7,DEMA_DownTicks);
   SetIndexBuffer(8,TVI_calculate);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"TVI 2");
      SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"TVI 2");

	if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
     MyPoint = Point*10;
	else if (Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1))
     MyPoint = Point*100;
	else
	  MyPoint = Point;

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
   return(0);
}

//+------------------------------------------------------------------+
//| Ticks Volume Indicator                                           |
//+------------------------------------------------------------------+
int start() {
   int i,counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   //----1///////////////////////
   for(i=0; i<limit; i++) {
      UpTicks[i]=(Volume[i]+(Close[i]-Open[i])/MyPoint)/2;
      DownTicks[i]=Volume[i]-UpTicks[i];
   }
   for(i=limit-1; i>=0; i--) {
      EMA_UpTicks[i]=iMAOnArray(UpTicks,0,r,0,MODE_EMA,i);
      EMA_DownTicks[i]=iMAOnArray(DownTicks,0,r,0,MODE_EMA,i);
   }
   for(i=limit-1; i>=0; i--) {
      DEMA_UpTicks[i]=iMAOnArray(EMA_UpTicks,0,s,0,MODE_EMA,i);
      DEMA_DownTicks[i]=iMAOnArray(EMA_DownTicks,0,s,0,MODE_EMA,i);
   }
   for(i=0; i<limit; i++)
      TVI_calculate[i]=100.0*(DEMA_UpTicks[i]-DEMA_DownTicks[i])/(DEMA_UpTicks[i]+DEMA_DownTicks[i]);
   for(i=limit-1; i>=0; i--) {
     if (iClose(NULL,0,i)==0)
       TVI[i]=EMPTY_VALUE;
     else
       TVI[i]=iMAOnArray(TVI_calculate,0,u,0,MODE_EMA,i);
   } 
   //----
   
   //----2///////////////////////
   /*
   for(i=0; i<limit; i++) {
      UpTicks[i]=(Volume[i]+(Close[i]-Open[i])/MyPoint)/2;
      DownTicks[i]=Volume[i]-UpTicks[i];
   }*/
   for(i=limit-1; i>=0; i--) {
      EMA_UpTicks[i]=iMAOnArray(UpTicks,0,r2,0,MODE_EMA,i);
      EMA_DownTicks[i]=iMAOnArray(DownTicks,0,r2,0,MODE_EMA,i);
   }
   for(i=limit-1; i>=0; i--) {
      DEMA_UpTicks[i]=iMAOnArray(EMA_UpTicks,0,s2,0,MODE_EMA,i);
      DEMA_DownTicks[i]=iMAOnArray(EMA_DownTicks,0,s2,0,MODE_EMA,i);
   }
   for(i=0; i<limit; i++)
      TVI_calculate[i]=100.0*(DEMA_UpTicks[i]-DEMA_DownTicks[i])/(DEMA_UpTicks[i]+DEMA_DownTicks[i]);
   for(i=limit-1; i>=0; i--) {
     if (iClose(NULL,0,i)==0)
       TVI2[i]=EMPTY_VALUE;
     else
       TVI2[i]=iMAOnArray(TVI_calculate,0,u2,0,MODE_EMA,i);
   } 
   //----
   
   
   
   
   
   
   return(0);
}
//+------------------------------------------------------------------+